﻿using System;

using UIKit;
using Infragistics;
using ObjCRuntime;
using Foundation;

namespace GridSwipeRowCS
{
	public partial class ViewController : UIViewController, IIGGridViewDelegate
	{
		IGGridView _grid;
		IGGridViewDataSourceHelper _dsh;
		IGGridViewDarkTheme _theme;
		IGRowPath _row;
		UIView _slideView;
		UIButton _button;
        private UIButton _button2;

        public ViewController (IntPtr handle) : base (handle)
		{
		}

		public override void ViewDidLoad ()
		{
			base.ViewDidLoad ();

			this.Title = "Example";
			this.View.BackgroundColor = UIColor.Yellow;

			_slideView = new UIView (new CoreGraphics.CGRect (0, 0, 400, 100));
            _slideView.BackgroundColor = UIColor.Cyan;

            _button = UIButton.FromType(UIButtonType.InfoDark);
            _button.Frame = new CoreGraphics.CGRect(200, 0, 200, 100);
            _button.AutoresizingMask = UIViewAutoresizing.FlexibleWidth | UIViewAutoresizing.FlexibleHeight;
            _button.AddTarget(this, new Selector("ShowDetails"), UIControlEvent.TouchUpInside);
            _button.BackgroundColor = UIColor.Blue;
            _slideView.Add(_button);


            _button2 = UIButton.FromType(UIButtonType.InfoDark);
            _button2.Frame = new CoreGraphics.CGRect(0, 0, 200, 100);
            _button2.AutoresizingMask = UIViewAutoresizing.FlexibleWidth | UIViewAutoresizing.FlexibleHeight;
            _button2.AddTarget(this, new Selector("ShowDetails"), UIControlEvent.TouchUpInside);
            _button2.BackgroundColor = UIColor.Red;
            _slideView.Add(_button2);

            _grid = new IGGridView (this.View.Bounds, IGGridViewStyle.IGGridViewStyleDefault);
			_grid.AutoresizingMask = UIViewAutoresizing.FlexibleHeight | UIViewAutoresizing.FlexibleWidth;
			_grid.RowHeight = UIDevice.CurrentDevice.UserInterfaceIdiom == UIUserInterfaceIdiom.Phone ? 60 : 100;
			_grid.EmptyRows = false;
			_grid.HeaderHeight = 0;
			_grid.Theme = _theme = new IGGridViewDarkTheme ();
			_grid.SwipeRowAction = IGGridViewSwipeRowAction.IGGridViewSwipeRowActionManualSlideLeft;
			_grid.WeakDelegate = this;
		    _grid.RowReordering = true;
		  //  _grid.SlideRowRightWidth = 250;
            _grid.SlideRowLeftWidth= 400;
			this.View.AddSubview (_grid);

			_dsh = new IGGridViewDataSourceHelper ();
			_dsh.Data = IGSalesmanItem.GenerateData (100).ToArray ();
		    _dsh.AllowRowReordering = true;

            var sortCol = new IGGridViewSortedColumn("lastName",
            IGGridViewSortedColumnDirection.IGGridViewSortedColumnDirectionAscending);

            _dsh.SortedColumns.Add(sortCol);



            _grid.DataSource = _dsh;


            UILabel label = new UILabel(this.View.Bounds);
            label.AutoresizingMask = UIViewAutoresizing.FlexibleHeight | UIViewAutoresizing.FlexibleWidth;
            label.Lines = 0;
            label.TextAlignment = UITextAlignment.Center;
            label.Font = UIFont.FromName("Helvetica-Light", 26.0f);
            label.Text = "XXXX";
            this.NavigationController.Toolbar.AddSubview(label);

            _dsh.InvalidateData(true);
            _grid.UpdateData();

		    NavigationController.Toolbar.Hidden = false;
		}

		public override void DidReceiveMemoryWarning ()
		{
			base.DidReceiveMemoryWarning ();
		}

		[Export ("gridView:canSlideRowLeft:")]
		public bool CanSlideRowLeft (Infragistics.IGGridView gridView, Infragistics.IGRowPath path)
		{
			return true;
		}

		[Export ("gridView:viewForSlideRowLeft:")]
		public UIKit.UIView ResolveSlideRowLeftView (Infragistics.IGGridView gridView, Infragistics.IGRowPath path)
		{
			_row = path;
			return _slideView;
		}

		[Export("ShowDetails")]
		public void ShowDetails()
		{
			DetailViewController detailViewController = new DetailViewController ();
			this.NavigationController.PushViewController (detailViewController, true);
		}
	}
}

